#trials numbers
nsim = 10^7

#input quantities
meanA = 6.141
meanB = 4.219
meanC = 2.321
deltaABC = .02

#generate of random numbers
randA <- runif(nsim,meanA - deltaABC, meanA + deltaABC) 
randB <- runif(nsim,meanB - deltaABC, meanB + deltaABC) 
randC <- runif(nsim,meanC - deltaABC, meanC + deltaABC) 

#model of measurement
randV = randA*randB*randC
meanV = mean(randV)                                     

#function for calculating the shortest coverage interval
sci <- function (values, alpha){
  sortedSim <- sort(values)
  nsim <- length(values)
  covInt <- sapply(1:(nsim-round((1-alpha)*nsim)), function(i) {
    sortedSim[1+round((1-alpha)*nsim)+(i-1)]-sortedSim[1+(i-1)]})
  lcl <- sortedSim[which(covInt==min(covInt))]
  ucl <- sortedSim[1+round((1-alpha)*nsim)+(which(covInt==min(covInt))-1)]
  c(lcl, ucl)
}

#shortest 95% coverage interval
(simInt <- round(sci(randV, alpha=.05), 4))

#plot the histogram
hist(randV, breaks = seq(min(randV)-0.05, max(randV)+0.05 ,0.05), probability = 1, axes = F, border = "white", col = rgb(0.75,0,0),xlab = "Volume [cm^3]",ylab = "Density of Probability",main = "")
vgrid <- seq(0, 1, 0.2) 
abline(h=vgrid, col="grey", lty=2) 
hist(randV, add=TRUE, breaks = seq(min(randV)-0.05, max(randV)+0.05 ,0.05), probability = 1, axes = F, border = "white", col = rgb(0.75,0,0),xlab = "Volume [cm^3]",ylab = "Density of Probability",main = "")
abline(v=simInt, col="gray", lty=1, lwd=2)
axis(side=1, at=seq(0,1000,0.25))
axis(side=2, at=seq(0,1, 0.2), labels = seq(0,1, 0.2))

#output quantity
meanV
(simInt[2]-simInt[1])/2
