#trials numbers
nsim = 10^7

#input quantities
meanm = .069424187
meanV = .6014861501
deltam = .01
deltaV = .0116534395

#generate of random numbers
randm <- runif(nsim,meanm - deltam, meanm + deltam) 
randV <- runif(nsim,meanV - deltaV, meanV + deltaV) 


#model of measurement
randRo = randm/randV
meanRo = mean(randRo)                                     

#function for calculating the shortest coverage interval
sci <- function (values, alpha){
  sortedSim <- sort(values)
  nsim <- length(values)
  covInt <- sapply(1:(nsim-round((1-alpha)*nsim)), function(i) {
    sortedSim[1+round((1-alpha)*nsim)+(i-1)]-sortedSim[1+(i-1)]})
  lcl <- sortedSim[which(covInt==min(covInt))]
  ucl <- sortedSim[1+round((1-alpha)*nsim)+(which(covInt==min(covInt))-1)]
  c(lcl, ucl)
}

#shortest 95% coverage interval
(simInt <- round(sci(randRo, alpha=.05), 4))

#plot the histogram
hist(randRo, breaks = seq(min(randRo)-0.001, max(randRo)+0.001 ,0.001), probability = 1, axes = F, border = "white", col = rgb(0.75,0,0),xlab = "Density [kg/m^3]",ylab = "Density of Probability",main = "")
vgrid <- seq(0, 100, 5) 
abline(h=vgrid, col="grey", lty=2) 
hist(randRo, add=TRUE, breaks = seq(min(randRo)-0.001, max(randRo)+0.001 ,0.001), probability = 1, axes = F, border = "white", col = rgb(0.75,0,0),xlab = "Density [kg/m^3]",ylab = "Density of Probability",main = "")
abline(v=simInt, col="gray", lty=1, lwd=2)
axis(side=1, at=seq(0,0.5,0.005))
axis(side=2, at=seq(0,100, 5), labels = seq(0,100, 5))

#output quantity
meanRo
(simInt[2]-simInt[1])/2
