#trials numbers
nsim = 10^7

#input quantities
Vin = 10
R1 = 220
R2 = 1000
deltaVin = .01
deltaR1 = 11
deltaR2 = 50

#generate of rand numbers
randVin <- runif(nsim,Vin - deltaVin, Vin + deltaVin)
randR1 <- runif(nsim,R1 - deltaR1, R1 + deltaR1)
randR2 <- runif(nsim,R2 - deltaR2, R2 + deltaR2)

#model of measurement
randVout = randVin*(randR2/(randR1+randR2))
meanVout = mean(randVout)                                     

#function for calculating the shortest coverage interval
sci <- function (values, alpha){
  sortedSim <- sort(values)
  nsim <- length(values)
  covInt <- sapply(1:(nsim-round((1-alpha)*nsim)), function(i) {
    sortedSim[1+round((1-alpha)*nsim)+(i-1)]-sortedSim[1+(i-1)]})
  lcl <- sortedSim[which(covInt==min(covInt))]
  ucl <- sortedSim[1+round((1-alpha)*nsim)+(which(covInt==min(covInt))-1)]
  c(lcl, ucl)
}

#shortest 95% coverage interval
(simInt <- round(sci(randVout, alpha=.05), 4))

#plot the histogram
hist(randVout, breaks = seq(min(randVout)-0.05, max(randVout)+0.05 ,0.01), probability = TRUE, axes = F, border = "white", col = rgb(0.75,0,0),xlab = "Output Voltage [V]",ylab = "Density of Probability",main = "")
vgrid <- seq(0, 6, 1) 
abline(h=vgrid, col="grey", lty=2) 
hist(randVout,add=TRUE, breaks = seq(min(randVout)-0.05, max(randVout)+0.05 ,0.01), probability = TRUE, axes = F, border = "white", col = rgb(0.75,0,0),xlab = "Output Voltage [V]",ylab = "Density of Probability",main = "")
abline(v=simInt, col="grey", lty=1, lwd=2)
axis(side=1, at=seq(0,10,0.05))
axis(side=2, at=seq(0,1000, 1), labels = seq(0,1000,1))

#output quantity
meanVout
(simInt[2]-simInt[1])/2
