#trials numbers
nsim = 10^7

#input quantities
meanU = 4.340
meanI = 95.969E-3
deltaU = .195E-3
deltaI= 1.13E-3

#generate of random numbers
randV <- runif(nsim,meanU - deltaU, meanU + deltaU) 
randI <- runif(nsim,meanI - deltaI, meanI + deltaI) 

#model of measurement
randP = randI-(2*randV/10e5)
meanP = mean(randP)                                     

#function for calculating the shortest coverage interval
sci <- function (values, alpha){
  sortedSim <- sort(values)
  nsim <- length(values)
  covInt <- sapply(1:(nsim-round((1-alpha)*nsim)), function(i) {
    sortedSim[1+round((1-alpha)*nsim)+(i-1)]-sortedSim[1+(i-1)]})
  lcl <- sortedSim[which(covInt==min(covInt))]
  ucl <- sortedSim[1+round((1-alpha)*nsim)+(which(covInt==min(covInt))-1)]
  c(lcl, ucl)
}

#shortest 95% coverage interval
(simInt <- round(sci(randP, alpha=.05), 4))

#plot the histogram
hist(randP)
hist(randP, breaks = seq(min(randP)-0.0001, max(randP)+0.0001 ,0.0001), probability = 1, axes = F, border = "white", col = rgb(0.75,0,0),xlab = "Resistance [Ohm]",ylab = "Density of Probability",main = "")
vgrid <- seq(0, 1, 0.2) 
abline(h=vgrid, col="grey", lty=2) 
hist(randP, add=TRUE, breaks = seq(min(randP)-0.07, max(randP)+0.05 ,0.02), probability = 1, axes = F, border = "white", col = rgb(0.75,0,0),xlab = "Resistance [Ohm]",ylab = "Density of Probability",main = "")
abline(v=simInt, col="gray", lty=1, lwd=2)
axis(side=1, at=seq(0,100,0.1))
axis(side=2, at=seq(0,1, 0.2), labels = seq(0,1, 0.2))

#output quantity
meanR
(simInt[2]-simInt[1])/2
